#!/usr/bin/perl

# number of command line arguments
$nargv = @ARGV;


@fields = ("name","size","nz","time_IO","nz1","time_COMP","value");

# get the siz eof the problems first
($sizesp, $nfiles) = &get_values("size");
@sizes = @$sizesp;

# get casenames 
($casenamesp, $nfiles) = &get_values("name");
@casenames = @$casenamesp;

# work on each file specified in the command line
foreach $field (@fields)
{


    ($valuesp, $nfiles) = &get_values($field);
    @values = @$valuesp;

    $nvalues = @values/$nfiles;
    # initialise total scores
    for ($i = 0; $i < $nfiles; $i++)
    {
	$total_score[$i] = 0;
    }
    #dump field for all methods
    printf "%20s ====== \n",$field;
    print "@ARGV","\n";
    for ($k = 0; $k < $nvalues; $k++)
    {
	printf "%20s %10s ",$casenames[$k],$sizes[$k];
	for ($i = 0; $i < $nfiles; $i++)
	{
#	    printf "%13s",$values[$i*$nvalues+$k]
	    printf "%10.3f",$values[$i*$nvalues+$k]
	}
	print "\n";
    }
    # calculating score
#    SIZES: foreach $minsz ("0","1000","5000","10000","50000","100000"){
#    SIZES: foreach $minsz ("37","111","333","1000","3000","9000","27000","71000"){
    SIZES: foreach $minsz ("1"){
#  SIZES: foreach $minsz ("25","100","400","1600","6400","25600","102400"){
	print "=========== scores for cases with size >= $minsz \n";
	@total_score = ();
	for ($i = 0; $i < $nfiles; $i++)
	{
	    printf "%20s || %20s (%2s) ",$field,$ARGV[$i],$i+1;
	    for ($j = 0; $j < $nfiles; $j++)
	    {
		$score = 0;
		$nentry = 0;
		for ($k = 0; $k < $nvalues; $k++)
		{
		    if ($sizes[$k] >= $minsz ) {
			$nentry++;
			if ($values[$i*$nvalues+$k] == 0) 
			{
			    $score = $score + 1;
			}
			else
			{
			    $score = $score + $values[$j*$nvalues+$k]/$values[$i*$nvalues+$k];
			}
		    }
		}
		if ($nentry <= 0)
		{
		    last SIZES;
		}
		printf "%10.3f", $score/$nentry;
		$total_score[$j] = $total_score[$j] + $score/$nentry;
	    }
	    print "\n";
	    
	}
	# print total scores
	printf "%50s"," ";
	for ($i = 0; $i < $nfiles; $i++)
	{
	    printf "%10.3f",$total_score[$i]/$nfiles;
	}
        # print method names
	printf "\n%50s"," ";
	for ($i = 0; $i < $nfiles; $i++)
	{
	    printf "      (%2s)",$i+1;
	}

	print "\n";
	for ($i = 0; $i < $nfiles; $i++)
	{
	    printf "%10s ",$ARGV[$i];
	}
	print " $nentry out of $nvalues cases are of such size\n";
	print "\n";
	
    }

}


sub get_values{
# get the values of a field. The inputput files are all in the form:
# a1, x11, a2, x12, ... an, x1n
# ....  ....
# a1, xm1, a2, xm2, ... an, xmn
#
# where a is the field name and x is the value
# &get_value(ai) will return the reference to the 
# array ((x1i, x2i, ..., xmi), ...) and the number of files
# read. If there are 3 files, and each has m rows, then
# the returned array has 3m elements.
# for example, 
# file1: 
#   key1 3 key2 4
#   key1 5 key2 6
# file2: 
#   key1 6 key2 8
#   key1 9 key2 10
# then get_values("key2") return
# (4,6,8,10) and 2 ($nfiles)
    my $field = shift;
    my @values = ();
    my $nfiles = 0;
    my $filename;
    foreach $filename (@ARGV)
    {
	$nfiles = $nfiles + 1;
	open(MYFILE,$filename) or die "can't open file $filename: $!\n";
	EACHFILE: while ($line = <MYFILE>)
	{
	    my @tokens = split(" ",$line);
	    my $found = 0;
	    EACHLINE: foreach $token (@tokens)
	    {
		if ($found == 1) 
		{
		    push(@values, $token);
		    last EACHLINE;
		}
		if ($token eq $field)
		{
		    $found = 1;
		}
	    }
	}
	close MYFILE;
    }
    return (\@values, $nfiles);
    
}
