#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <errno.h>
#include <time.h>
#include <math.h>

extern int ler_segmento(FILE *, float *, int , int );
extern int escreve_segmento(FILE *, float *, int );
extern int exemplo1(int, float *, float *);
extern int exemplo2(int, float *, float *);
extern int exemplo3(int, float *, float *);


int main(int argc, char *argv[])
{
clock_t start = 0, end = 0;
double elapsed;
FILE *fp_o, *fp_d;
char cInputFile[20], cOutputFile[20];
float *signal_in, *signal_out;
int tam_dados = 0, n_dados_lidos = 0;

   if (argc==4){
      strcpy(cInputFile,argv[1]);
      tam_dados = atoi(argv[2]);
      strcpy(cOutputFile,argv[3]);
   }
   else {
      printf("%s \n", strerror(EINVAL));
      printf("Usage: %s (v0.0) <fich dados> <dimensao> <fich resultados> \n", argv[0]);
      return(1);
   }

   signal_in = (float *) malloc(sizeof(float)*tam_dados);
   if (signal_in==NULL) {
      printf("%s \n", strerror(ENOMEM));
      fprintf(stderr,
         "Could not allocate memory for the data segment length of %d",
         tam_dados);
      exit(1);
   }

   signal_out = (float *) malloc(sizeof(float)* tam_dados);
   if (signal_out==NULL) {
      printf("%s \n", strerror(ENOMEM));
      fprintf(stderr,
         "Could not allocate memory for the data segment length of %d",
         tam_dados);
      exit(1);
   }

      fp_o=fopen(cInputFile,"r");
      if (fp_o == NULL)
      {
         fprintf(stderr,"Error opening input file \n");
         exit(1);
      }
      
      if ((n_dados_lidos = ler_segmento(fp_o, signal_in, 0, tam_dados-1)) < 0) {
		printf("Nmero de dados no ficheiro insuficiente \n");
		exit(1) ;
      }
      fclose(fp_o);

start = clock();
/* Do the work. */
exemplo1(n_dados_lidos, signal_in, signal_out);
exemplo2(n_dados_lidos, signal_in, signal_out);
exemplo3(n_dados_lidos, signal_in, signal_out);
/* Do the work. */
end = clock();

      fp_d=fopen(cOutputFile,"w");
      if (fp_d == NULL)
      {
         fprintf(stderr, "Error opening output file \n");
         exit(1);
      }
    escreve_segmento(fp_d, signal_out, n_dados_lidos );
    fclose(fp_d);

elapsed = ((double) (end - start)) / CLOCKS_PER_SEC ;
printf("Elapsed time %e seconds.\n", elapsed);

free(signal_in);
free(signal_out);

return (0);
}

